# -*- encoding : utf-8 -*-
require 'data_mapper'

#DataMapper::Logger.new($stdout, :debug)
DataMapper::Model.raise_on_save_failure = true
DataMapper.setup(:default, "sqlite://#{Dir.pwd}/data.db")

module Meiriyigua
  module Models
    class UrlRecord
      include DataMapper::Resource

      property :id, Serial
      property :url, String, length: 1024
      property :detail_at, DateTime
      property :baidu_at, DateTime
      property :publish_at, DateTime
      property :created_at, DateTime
      property :updated_at, DateTime

      has 1, :page_record

      def self.exist_url?(url)
        self.count(url: url) > 0
      end
    end

    class PageRecord
      include DataMapper::Resource

      property :id, Serial
      property :title, String, length: 1024
      property :category, String, length: 1024
      property :content, Text
      property :downloads, Text
      property :baidu_intro, Text
      property :created_at, DateTime
      property :updated_at, DateTime

      belongs_to :url_record
    end
  end
end

DataMapper.finalize

DataMapper.auto_upgrade!
